# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class IaasapiimageprofilesImageMapping(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'external_id': 'str',
        'constraints': 'list[IaasapinetworksConstraints]',
        'cloud_config': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'external_id': 'externalId',
        'constraints': 'constraints',
        'cloud_config': 'cloudConfig'
    }

    def __init__(self, id=None, name=None, external_id=None, constraints=None, cloud_config=None):  # noqa: E501
        """IaasapiimageprofilesImageMapping - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._external_id = None
        self._constraints = None
        self._cloud_config = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if external_id is not None:
            self.external_id = external_id
        if constraints is not None:
            self.constraints = constraints
        if cloud_config is not None:
            self.cloud_config = cloud_config

    @property
    def id(self):
        """Gets the id of this IaasapiimageprofilesImageMapping.  # noqa: E501

        The id of the fabric image  # noqa: E501

        :return: The id of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IaasapiimageprofilesImageMapping.

        The id of the fabric image  # noqa: E501

        :param id: The id of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this IaasapiimageprofilesImageMapping.  # noqa: E501

        Fabric image name. Valid if id not provided.   # noqa: E501

        :return: The name of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IaasapiimageprofilesImageMapping.

        Fabric image name. Valid if id not provided.   # noqa: E501

        :param name: The name of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def external_id(self):
        """Gets the external_id of this IaasapiimageprofilesImageMapping.  # noqa: E501

        External entity Id. Valid if id and name are not provided.  # noqa: E501

        :return: The external_id of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :rtype: str
        """
        return self._external_id

    @external_id.setter
    def external_id(self, external_id):
        """Sets the external_id of this IaasapiimageprofilesImageMapping.

        External entity Id. Valid if id and name are not provided.  # noqa: E501

        :param external_id: The external_id of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :type: str
        """

        self._external_id = external_id

    @property
    def constraints(self):
        """Gets the constraints of this IaasapiimageprofilesImageMapping.  # noqa: E501

        Constraints that are used to drive placement policies for the image that is produced from this mapping.Constraint expressions are matched against tags on existing placement targets.  # noqa: E501

        :return: The constraints of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :rtype: list[IaasapinetworksConstraints]
        """
        return self._constraints

    @constraints.setter
    def constraints(self, constraints):
        """Sets the constraints of this IaasapiimageprofilesImageMapping.

        Constraints that are used to drive placement policies for the image that is produced from this mapping.Constraint expressions are matched against tags on existing placement targets.  # noqa: E501

        :param constraints: The constraints of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :type: list[IaasapinetworksConstraints]
        """

        self._constraints = constraints

    @property
    def cloud_config(self):
        """Gets the cloud_config of this IaasapiimageprofilesImageMapping.  # noqa: E501

        Cloud config for this image. This cloud config will be merged during provisioning with other cloud configurations such as the bootConfig provided in MachineSpecification.  # noqa: E501

        :return: The cloud_config of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :rtype: str
        """
        return self._cloud_config

    @cloud_config.setter
    def cloud_config(self, cloud_config):
        """Sets the cloud_config of this IaasapiimageprofilesImageMapping.

        Cloud config for this image. This cloud config will be merged during provisioning with other cloud configurations such as the bootConfig provided in MachineSpecification.  # noqa: E501

        :param cloud_config: The cloud_config of this IaasapiimageprofilesImageMapping.  # noqa: E501
        :type: str
        """

        self._cloud_config = cloud_config

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IaasapiimageprofilesImageMapping, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IaasapiimageprofilesImageMapping):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
